public void populateCarouselAsset(DspCreative dspCreative, GeminiAdAsset geminiAdAsset) {
    GeminiAdAssetType matchType = geminiAdAsset.getType();
    Set<NativeDetails> existingNativeDetails = dspCreative.getDetails().getNativeDetails();
    if (matchType == GeminiAdAssetType.MULTI_IMAGE) {
        dspCreative.setFormatType(CreativeFormatEnum.CAROUSEL.getFormatType());
        dspCreative.setFormatValue(CreativeFormatEnum.CAROUSEL.getFormatValue());
    }
    NativeDetails nativeDetails = new NativeDetails();
    NativeAssets nativeAssets = new NativeAssets();

    // populate DSP native details
    nativeDetails.setAllowVideoAutoloop(geminiAdAsset.getVideoAutoloop());
    nativeDetails.setTitle(geminiAdAsset.getTitle());
    if (nativeDetails.getTitle() == null) {
        nativeDetails.setTitle(dspCreative.getDetails().getTitle());
    }
    nativeDetails.setDescription(geminiAdAsset.getDescription());
    nativeDetails.setCallToAction(geminiAdAsset.getCallToActionText());
    if (StringUtils.isEmpty(nativeDetails.getCallToAction())) {
        setDefaultCTA(nativeDetails, dspCreative.getLanguageId()));
    }
    nativeDetails.setLandingPageUrl(geminiAdAsset.getLandingUrl());
    nativeDetails.setLandingPageDomain(geminiAdAsset.getLandingUrl());
    nativeDetails.setCardIndex(geminiAdAsset.getIndex());

    // populate DSP native assets
    nativeAssets.setImageSecuredUrl(geminiAdAsset.getImageUrlHQ());
    nativeAssets.setImageUnsecuredUrl(geminiAdAsset.getImageUrlHQ());
    nativeAssets.setIconImageSecuredUrl(geminiAdAsset.getImageUrl());
    nativeAssets.setIconImageUnsecuredUrl(geminiAdAsset.getImageUrl());
    nativeAssets.setCreativeFileUrl(geminiAdAsset.getVideoPrimaryUrl());
    nativeDetails.setNativeAssets(nativeAssets);

    // adding DSP native details to DSP creative details
    Set<NativeDetails> nativeDetailsSet = new HashSet<>();
    if (CollectionUtils.isEmpty(existingNativeDetails)) {
        nativeDetailsSet.add(nativeDetails);
    } else {
        Iterator<NativeDetails> iterator = existingNativeDetails.iterator();
        while (iterator.hasNext()) {
            NativeDetails value = iterator.next();
            //if new Ad asset, add transformed value of current ad asset
            if (isNull(value.getCardIndex())) {
                nativeDetailsSet.add(nativeDetails);
            } else {
                //retain existing values along with current native asset
                nativeDetailsSet.add(value);
                nativeDetailsSet.add(nativeDetails);
            }
        }
    }
    dspCreative.getDetails().setNativeDetails(nativeDetailsSet);
}