public void populateTilesAsset(DspCreative dspCreative, GeminiAdAsset geminiAdAsset) {
    CustomLandingPageTile customLandingPageTile = new CustomLandingPageTile();
    customLandingPageTile.setType(TileType.valueOf(geminiAdAsset.getType().name()));
    customLandingPageTile.setStatus(geminiAdAsset.getStatus().name().equals(GeminiStatus.DELETED.name()) ? TileStatus.DELETED : TileStatus.ACTIVE);
    customLandingPageTile.setFixedPosition(TileFixedPosition.valueOf(geminiAdAsset.getFixedPosition().name()));
    customLandingPageTile.setFit(Boolean.TRUE.equals(geminiAdAsset.getFitToHeight()) ? TileFit.FIT_TO_HEIGHT : TileFit.NONE);
    customLandingPageTile.setLandingUrl(geminiAdAsset.getLandingUrl());
    customLandingPageTile.setAssetUrl(geminiAdAsset.getAssetUrl());
    customLandingPageTile.setIndex(geminiAdAsset.getIndex());
    customLandingPageTile.setVerticalIndex(geminiAdAsset.getVerticalIndex());

    // adding tiles custom landing page info to creative details
    CreativeDetails creativeDetails = dspCreative.getDetails();
    CustomLandingPage customLandingPage = creativeDetails.getCustomLandingPage();
    Set<CustomLandingPageTile> tiles = customLandingPage.getTiles();
    tiles.add(customLandingPageTile);
}