public void populateTouchpointsAsset(DspCreative dspCreative, GeminiAdAsset geminiAdAsset) {
    Set<NativeDetails> existingNativeDetails = creative.getDetails().getNativeDetails();
    // populate DSP native asset
    NativeAsset nativeAsset = new NativeAsset();
    nativeAsset.setType(geminiAdAsset.getType());
    nativeAsset.setTemplateType(geminiAdAsset.getTemplateType());
    nativeAsset.setLandingUrl(geminiAdAsset.getLandingUrl());
    nativeAsset.setAssetIndex(geminiAdAsset.getIndex());

    String assetURL = Optional.ofNullable(geminiAdAsset.getImageUrlHQ()).orElse(geminiAdAsset.getImageUrl());
    nativeAsset.setAssetUrl(assetURL);

    // set DSP styles
    if (nonNull(geminiAdAsset.getStyles())) {
        nativeAsset.setStyles(new NativeAssetStyles());
        nativeAsset.getStyles().setX(geminiAdAsset.getStyles().getX());
        nativeAsset.getStyles().setH(geminiAdAsset.getStyles().getH());
        nativeAsset.getStyles().setW(geminiAdAsset.getStyles().getW());
        nativeAsset.getStyles().setY(geminiAdAsset.getStyles().getY());
        nativeAsset.getStyles().setZ(geminiAdAsset.getStyles().getZ());
    }

    // adding DSP native asset to touchpoints
    Iterator<NativeDetails> iterator = existingNativeDetails.iterator();
    NativeDetails existingDetails = iterator.next();
    List<NativeAsset> touchpoints = existingDetails.getNativeAssets().getTouchpoints();
    nativeAsset.setAssetIndex(touchpoints.size());
    touchpoints.add(nativeAsset);
    existingDetails.getNativeAssets().setTouchpoints(touchpoints);
}