  private void populateMailSponsored(GeminiAdAsset geminiAdAsset, Creative creative) {
      creative.setFormatValue(CreativeFormatEnum.MAIL_SPONSORED.getFormatValue());
      creative.setFormatType(CreativeFormatEnum.MAIL_SPONSORED.getFormatType());

      String mailAssetUrl = geminiAdAsset.getMailAssetUrl();
      NativeDetails nativeDetails = creative.getDetails().getNativeDetails().iterator().next();
      NativeAssets nativeAssets = nativeDetails.getNativeAssets();
      if (!mailAssetUrl.endsWith(HTML_MAIL_POSTFIX)) {// mail image ad
          String extension = mailAssetUrl.substring(mailAssetUrl.lastIndexOf(".") + 1);
          MIMEType mimeType = MIMEType.getMIMETypeByExtension(extension);
          if (mimeType != null) {
              creative.setMimeTypeId(mimeType.getId());
          }
          nativeAssets.setHtmlUrl(null);
      } else {// mail html ad
          creative.setMimeTypeId(MIMEType.HTML.getId());
          nativeAssets.setHtmlUrl(geminiAdAsset.getMailAssetUrl());
      }

      NativeBinaryContent nativeBinaryContent = new NativeBinaryContent();
      nativeDetails.setNativeBinaryContent(nativeBinaryContent);
      nativeAssets.setIconImageSecuredUrl(geminiAdAsset.getImageUrlThumbnail());
      nativeAssets.setIconImageUnsecuredUrl(geminiAdAsset.getImageUrlThumbnail());
      nativeAssets.setImageSecuredUrl(geminiAdAsset.getMailAssetUrl());
      nativeAssets.setSmallImageSecuredUrl(null);
  }